Index: /LMDZ6/branches/DYNAMICO-conv/bld.cfg
===================================================================
--- /LMDZ6/branches/DYNAMICO-conv/bld.cfg	(revision 3412)
+++ /LMDZ6/branches/DYNAMICO-conv/bld.cfg	(revision 3413)
@@ -66,5 +66,5 @@
 # Example of how to set specific compiling options for a specific file
 # -> this can be including in the arch.opt file
-#bld::tool::fflags::phys::readaerosol         %BASE_FFLAGS %PROD_FFLAGS  %INCDIR -C hopt -pi auto
+#bld::tool::fflags::phys::physiq_mod         %BASE_FFLAGS %DEBUG_FFLAGS  %INCDIR
 
 
Index: /LMDZ6/branches/DYNAMICO-conv/build_gcm
===================================================================
--- /LMDZ6/branches/DYNAMICO-conv/build_gcm	(revision 3412)
+++ /LMDZ6/branches/DYNAMICO-conv/build_gcm	(revision 3413)
@@ -45,6 +45,11 @@
 # run "fcm build" command
 ${dirname}fcm build $*
+status=$?
 
 # cleanup
 \rm -f '.lock' 
 
+if [ $status -ne 0 ]; then
+  exit $status
+fi
+
Index: /LMDZ6/branches/DYNAMICO-conv/libf/dynphy_lonlat/phylmd/etat0dyn_netcdf.F90
===================================================================
--- /LMDZ6/branches/DYNAMICO-conv/libf/dynphy_lonlat/phylmd/etat0dyn_netcdf.F90	(revision 3412)
+++ /LMDZ6/branches/DYNAMICO-conv/libf/dynphy_lonlat/phylmd/etat0dyn_netcdf.F90	(revision 3413)
@@ -100,5 +100,6 @@
 
   deg2rad = pi/180.0
-
+  y(:,:,:)=0  !ym warning unitialized variable
+  
 ! Compute psol AND tsol, knowing phis.
 !*******************************************************************************
Index: /LMDZ6/branches/DYNAMICO-conv/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90
===================================================================
--- /LMDZ6/branches/DYNAMICO-conv/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90	(revision 3412)
+++ /LMDZ6/branches/DYNAMICO-conv/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90	(revision 3413)
@@ -44,5 +44,5 @@
     zmax0,fevap, rnebcon,falb_dir, wake_fip,    agesno,  detr_therm, pbl_tke,  &
     phys_state_var_init, ql_ancien, qs_ancien, prlw_ancien, prsw_ancien, &
-    prw_ancien
+    prw_ancien, sollwdown
   USE comconst_mod, ONLY: pi, dtvr
 
@@ -200,4 +200,6 @@
   solsw      = 165.
   sollw      = -53.
+!ym warning missing init for sollwdown => set to 0
+  sollwdown  = 0.
   t_ancien   = 273.15
   q_ancien   = 0.
@@ -314,5 +316,8 @@
   ALLOCATE(zmea0(iml,jml),zstd0(iml,jml)) !--- Mean orography and std deviation
   ALLOCATE(zsig0(iml,jml),zgam0(iml,jml)) !--- Slope and nisotropy
+  zsig0(:,:)=0   !ym uninitialized variable
+  zgam0(:,:)=0   !ym uninitialized variable
   ALLOCATE(zthe0(iml,jml))                !--- Highest slope orientation
+  zthe0(:,:)=0   !ym uninitialized variable
   ALLOCATE(zpic0(iml,jml),zval0(iml,jml)) !--- Peaks and valley heights
 
Index: /LMDZ6/branches/DYNAMICO-conv/libf/misc/wxios.F90
===================================================================
--- /LMDZ6/branches/DYNAMICO-conv/libf/misc/wxios.F90	(revision 3412)
+++ /LMDZ6/branches/DYNAMICO-conv/libf/misc/wxios.F90	(revision 3413)
@@ -152,4 +152,5 @@
 !$OMP MASTER
         !Initialisation du contexte:
+        !!CALL xios_context_initialize(g_ctx_name, g_comm)
         CALL xios_context_initialize(g_ctx_name, COMM_LMDZ_PHY)
         CALL xios_get_handle(g_ctx_name, xios_ctx)    !Récupération
@@ -301,4 +302,5 @@
         CALL xios_set_domain_attr_hdl(dom, nj_glo=nbp_lat, jbegin=jj_begin-1, nj=jj_nb, data_dim=2)
         CALL xios_set_domain_attr_hdl(dom, lonvalue_1d=io_lon(1:nbp_lon), latvalue_1d=io_lat(jj_begin:jj_end))
+        CALL xios_set_domain_attr("dom_out", domain_ref=dom_id)
 
         IF (.NOT.is_sequential) THEN
@@ -332,4 +334,5 @@
         USE mod_phys_lmdz_para 
         USE nrtype, ONLY : PI
+        USE ioipsl_getin_p_mod, ONLY : getin_p
         IMPLICIT NONE
         CHARACTER(len=*),INTENT(IN) :: dom_id ! domain identifier
@@ -339,6 +342,6 @@
         REAL :: boundslat_mpi(klon_mpi,nvertex)
         INTEGER :: ind_cell_glo_mpi(klon_mpi)
-        TYPE(xios_domaingroup) :: dom
-
+        TYPE(xios_domain) :: dom
+        LOGICAL :: remap_output
 
         CALL gather_omp(longitude*180/PI,lon_mpi)
@@ -348,7 +351,9 @@
         CALL gather_omp(ind_cell_glo,ind_cell_glo_mpi)
         
+        remap_output=.TRUE.
+        CALL getin_p("remap_output",remap_output)
 
 !$OMP MASTER
-        CALL xios_get_domaingroup_handle(dom_id, dom)
+        CALL xios_get_domain_handle(dom_id, dom)
         
         !On parametrise le domaine:
@@ -357,4 +362,9 @@
                            bounds_lon_1d=TRANSPOSE(boundslon_mpi), bounds_lat_1d=TRANSPOSE(boundslat_mpi) )
         CALL xios_set_attr(dom, i_index=ind_cell_glo_mpi(:)-1)
+        IF (remap_output) THEN
+          CALL xios_set_domain_attr("dom_out", domain_ref="dom_regular")
+          CALL xios_set_fieldgroup_attr("dom_out", domain_ref="dom_regular")
+          CALL xios_set_fieldgroup_attr("remap_expr", expr="@this_ref")
+        ENDIF
 !$OMP END MASTER
 
Index: /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/conf_phys_m.F90
===================================================================
--- /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/conf_phys_m.F90	(revision 3412)
+++ /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/conf_phys_m.F90	(revision 3413)
@@ -1009,4 +1009,5 @@
     ! - 1 = stratospheric aerosols scaled from 550 nm AOD 
     ! - 2 = stratospheric aerosol properties from CMIP6
+    !Option 2 is only available with RRTM, this is tested later on 
     !Config Def  = 0
     !Config Help = Used in physiq.F
@@ -1014,7 +1015,5 @@
     !
     flag_aerosol_strat_omp = 0
-    IF (iflag_rrtm_omp==1) THEN
-      CALL getin('flag_aerosol_strat',flag_aerosol_strat_omp)
-    ENDIF
+    CALL getin('flag_aerosol_strat',flag_aerosol_strat_omp)
 
     !
Index: /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/cosp/phys_cosp.F90
===================================================================
--- /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/cosp/phys_cosp.F90	(revision 3412)
+++ /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/cosp/phys_cosp.F90	(revision 3413)
@@ -330,5 +330,4 @@
       !$OMP END MASTER
       !$OMP BARRIER
-        debut_cosp=.false.
       endif ! debut_cosp
 !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
@@ -341,5 +340,5 @@
 !        call cosp(overlap,Ncolumns,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,modis,rttov,stradar,stlidar)
 !#else
-        call cosp(overlap,Ncolumns,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,modis,stradar,stlidar)
+     if (.NOT. debut_cosp) call cosp(overlap,Ncolumns,cfg,vgrid,gbx,sgx,sgradar,sglidar,isccp,misr,modis,stradar,stlidar)
 !#endif
 !!
@@ -350,5 +349,5 @@
 
 !       print *, 'Calling write output'
-        call cosp_output_write(Nlevlmdz, Npoints, Ncolumns, itap, dtime, freq_COSP, missing_val, &
+     if (.NOT. debut_cosp) call cosp_output_write(Nlevlmdz, Npoints, Ncolumns, itap, dtime, freq_COSP, missing_val, &
                                cfg, gbx, vgrid, sglidar, sgradar, stlidar, stradar, & 
                                isccp, misr, modis)
@@ -376,4 +375,7 @@
 !  call system_clock(t1,count_rate,count_max)
 !  print *,(t1-t0)*1.0/count_rate
+    if (debut_cosp) then 
+      debut_cosp=.false.
+    endif
  
   CONTAINS 
Index: /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/create_etat0_unstruct.F90
===================================================================
--- /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/create_etat0_unstruct.F90	(revision 3412)
+++ /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/create_etat0_unstruct.F90	(revision 3413)
@@ -135,4 +135,8 @@
     rain_fall = 0.; snow_fall = 0.
     solsw = 165.;   sollw = -53.
+!ym warning missing init for sollwdown => set to 0
+  sollwdown  = 0.
+    
+    
     t_ancien = 273.15
     u_ancien=0
Index: /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/cv3_routines.F90
===================================================================
--- /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/cv3_routines.F90	(revision 3412)
+++ /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/cv3_routines.F90	(revision 3413)
@@ -3756,12 +3756,5 @@
         IF (i<=inb(il) .AND. nent(il,i)==0 .AND. iflag(il)<=1) THEN              ! cld
           qcond(il, i) = qcond(il, i) + (1.-ep(il,i))*clw(il, i)                 ! cld
-!jyg<   Bug correction 20180620
-!      PROBLEM: Should not qent(il,i,i) be taken into account even if nent(il,i)/=0?
-!!        qtment(il, i) = qent(il,k,i) + qtment(il,i)
-! cld
-          qtment(il, i) = qent(il,i,i) + qtment(il,i)
-! cld
-!>jyg
-
+          qtment(il, i) = qent(il,k,i) + qtment(il,i)                          ! cld
           nqcond(il, i) = nqcond(il, i) + 1.                                     ! cld
         END IF                                                                   ! cld
Index: /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/limit_read_mod.F90
===================================================================
--- /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/limit_read_mod.F90	(revision 3412)
+++ /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/limit_read_mod.F90	(revision 3413)
@@ -258,5 +258,5 @@
           ENDIF
           ierr=NF90_INQUIRE_DIMENSION(nid, ndimid, len=nn)
-          WRITE(abort_message,'(a,2(i3,a))')'limit.nc records number (',nn,') does no'//&
+          WRITE(abort_message,'(a,2(i0,a))')'limit.nc records number (',nn,') does no'//&
             't match year length (',year_len,')'
           IF(nn/=year_len) CALL abort_physic(modname,abort_message,1)
@@ -336,5 +336,5 @@
 
 !$OMP MASTER  ! Only master thread
-       IF (is_mpi_root) THEN ! Only master processus
+       IF (is_mpi_root) THEN ! Only master processus!
 
           ierr = NF90_OPEN ('limit.nc', NF90_NOWRITE, nid)
Index: /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/phys_state_var_mod.F90	(revision 3412)
+++ /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/phys_state_var_mod.F90	(revision 3413)
@@ -23,5 +23,5 @@
 !$OMP THREADPRIVATE(cvpas)
 !$OMP THREADPRIVATE(wkpas)
-      REAL, SAVE :: phys_tstep, solaire_etat0
+      REAL, SAVE :: phys_tstep=0, solaire_etat0
 !$OMP THREADPRIVATE(phys_tstep, solaire_etat0)
 
@@ -607,6 +607,8 @@
         du_gwd_rando(:,:)=0.
       ENDIF
-      if (.not. ok_hines .and. ok_gwd_rando) allocate(du_gwd_front(klon, klev))
-
+      IF (.not. ok_hines .and. ok_gwd_rando) THEN
+        ALLOCATE(du_gwd_front(klon, klev))
+        du_gwd_front(:,:) = 0 !ym missing init   
+      ENDIF
 END SUBROUTINE phys_state_var_init
 
Index: /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/physiq_mod.F90
===================================================================
--- /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/physiq_mod.F90	(revision 3412)
+++ /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/physiq_mod.F90	(revision 3413)
@@ -258,4 +258,7 @@
     USE climoz_mod
     USE limit_read_mod, ONLY : init_limit_read
+    USE regr_horiz_time_climoz_m, ONLY: regr_horiz_time_climoz
+    USE readaerosol_mod, ONLY : init_aero_fromfile
+    USE readaerosolstrato_m, ONLY : init_readaerosolstrato
 
 
@@ -1195,4 +1198,6 @@
        CALL phys_state_var_init(read_climoz)
        CALL phys_output_var_init
+       IF(read_climoz>=1 .AND. create_etat0_limit) CALL regr_horiz_time_climoz(read_climoz,ok_daily_climoz)
+
        print*, '================================================='
        !
@@ -1492,5 +1497,22 @@
        !
 
-       CALL create_climoz(read_climoz)
+!       CALL create_climoz(read_climoz)
+       CALL init_aero_fromfile(flag_aerosol)  !! initialise aero from file for XIOS interpolation (unstructured_grid)
+       CALL init_readaerosolstrato(flag_aerosol_strat)  !! initialise aero strato from file for XIOS interpolation (unstructured_grid)
+
+#ifdef CPP_COSP
+       CALL phys_cosp(itap,phys_tstep,freq_cosp, &
+               ok_mensuelCOSP,ok_journeCOSP,ok_hfCOSP, &
+               ecrit_mth,ecrit_day,ecrit_hf, ok_all_xml, missing_val, &
+               klon,klev,longitude_deg,latitude_deg,presnivs,overlap, &
+               JrNt,ref_liq,ref_ice, &
+               pctsrf(:,is_ter)+pctsrf(:,is_lic), &
+               zu10m,zv10m,pphis, &
+               zphi,paprs(:,1:klev),pplay,zxtsol,t_seri, &
+               qx(:,:,ivap),zx_rh,cldfra,rnebcon,flwc,fiwc, &
+               prfl(:,1:klev),psfl(:,1:klev), &
+               pmflxr(:,1:klev),pmflxs(:,1:klev), &
+               mr_ozone,cldtau, cldemi)
+#endif
 
        CALL phys_output_write(itap, pdtphys, paprs, pphis,                    &
@@ -1504,6 +1526,6 @@
        IF (is_omp_master) CALL xios_update_calendar(1)
 #endif
+       IF(read_climoz>=1 .AND. create_etat0_limit) CALL regr_horiz_time_climoz(read_climoz,ok_daily_climoz)
        CALL create_etat0_limit_unstruct
-
        CALL phyetat0 ("startphy.nc",clesphy0,tabcntr0)
 
@@ -1535,7 +1557,4 @@
        ENDIF
 
-       CALL printflag( tabcntr0,radpas,ok_journe, &
-            ok_instan, ok_region )
-       !
 !       IF (ABS(phys_tstep-pdtphys).GT.0.001) THEN
 !          WRITE(lunout,*) 'Pas physique n est pas correct',phys_tstep, &
@@ -4733,13 +4752,14 @@
        !         write(97) u_seri,v_seri,t_seri,q_seri
        !         close(97)
-!       !$OMP MASTER
-       IF (read_climoz >= 1) THEN
-          IF (is_mpi_root) THEN
-             CALL nf95_close(ncid_climoz)
-          ENDIF
-          DEALLOCATE(press_edg_climoz) ! pointer
-          DEALLOCATE(press_cen_climoz) ! pointer
-       ENDIF
-!       !$OMP END MASTER
+      
+       IF (is_omp_master) THEN
+       
+         IF (read_climoz >= 1) THEN
+           IF (is_mpi_root) CALL nf95_close(ncid_climoz)
+            DEALLOCATE(press_edg_climoz) ! pointer
+            DEALLOCATE(press_cen_climoz) ! pointer
+         ENDIF
+       
+       ENDIF
 #ifdef CPP_XIOS
        IF (is_omp_master) CALL xios_context_finalize
Index: /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/radlwsw_m.F90
===================================================================
--- /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/radlwsw_m.F90	(revision 3412)
+++ /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/radlwsw_m.F90	(revision 3413)
@@ -385,4 +385,8 @@
   lldebug=.FALSE.
 
+  ztopsw_aero(:,:)  = 0. !ym missing init : warning : not initialized in SW_AEROAR4
+  ztopsw0_aero(:,:) = 0. !ym missing init : warning : not initialized in SW_AEROAR4
+  zsolsw_aero(:,:)  = 0. !ym missing init : warning : not initialized in SW_AEROAR4
+  zsolsw0_aero(:,:) = 0. !ym missing init : warning : not initialized in SW_AEROAR4
   
   !
@@ -597,8 +601,4 @@
       ztopswaiaero(i)=0.
       zsolswaiaero(i)=0.
-      ztopsw_aero(i,:)  = 0. !ym missing init : warning : not initialized in SW_AEROAR4
-      ztopsw0_aero(i,:) = 0. !ym missing init : warning : not initialized in SW_AEROAR4
-      zsolsw_aero(i,:)  = 0. !ym missing init : warning : not initialized in SW_AEROAR4
-      zsolsw0_aero(i,:) = 0. !ym missing init : warning : not initialized in SW_AEROAR4
       ENDDO
 !     print *,'Avant SW_LMDAR4: PSCT zrmu0 zfract',PSCT, zrmu0, zfract
Index: /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/readaerosol.F90
===================================================================
--- /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/readaerosol.F90	(revision 3412)
+++ /LMDZ6/branches/DYNAMICO-conv/libf/phylmd/readaerosol.F90	(revision 3413)
@@ -4,4 +4,11 @@
 
   REAL, SAVE :: not_valid=-333.
+  
+  INTEGER, SAVE :: nbp_lon_src
+!$OMP THREADPRIVATE(nbp_lon_src)  
+  INTEGER, SAVE :: nbp_lat_src
+!$OMP THREADPRIVATE(nbp_lat_src)  
+  REAL, ALLOCATABLE, SAVE    :: psurf_interp(:,:)
+!$OMP THREADPRIVATE(psurf_interp)  
 
 CONTAINS
@@ -167,4 +174,74 @@
 
 
+  SUBROUTINE init_aero_fromfile(flag_aerosol)
+  USE netcdf
+  USE mod_phys_lmdz_para
+  USE mod_grid_phy_lmdz, ONLY: grid_type, unstructured
+  USE xios
+  IMPLICIT NONE
+  INTEGER, INTENT(IN) :: flag_aerosol
+  REAL,ALLOCATABLE :: lat_src(:)
+  REAL,ALLOCATABLE :: lon_src(:)
+  CHARACTER(LEN=*),PARAMETER :: file_aerosol='aerosols.nat.nc'
+  CHARACTER(LEN=*),PARAMETER :: file_so4='so4.nat.nc'
+  INTEGER :: klev_src
+  INTEGER :: ierr ,ncid, dimID, varid
+  REAL :: null_array(0)
+
+  IF (flag_aerosol>0 .AND. grid_type==unstructured) THEN
+  
+    IF (is_omp_root) THEN
+  
+      IF (is_mpi_root) THEN
+    
+        IF (nf90_open(TRIM(file_aerosol), NF90_NOWRITE, ncid) /= NF90_NOERR) THEN
+          CALL check_err( nf90_open(TRIM(file_so4), NF90_NOWRITE, ncid), "pb open "//trim(file_so4) )
+        ENDIF
+
+        ! Read and test longitudes
+        CALL check_err( nf90_inq_dimid(ncid, "lon", dimID),"pb inq dim lon") 
+        CALL check_err( nf90_inquire_dimension(ncid, dimID, len = nbp_lon_src),"pb inq dim lon")
+        CALL check_err( nf90_inq_varid(ncid, 'lon', varid),"pb inq lon" )
+        ALLOCATE(lon_src(nbp_lon_src))
+        CALL check_err( nf90_get_var(ncid, varid, lon_src(:)),"pb get lon" )
+
+        ! Read and test latitudes
+        CALL check_err( nf90_inq_dimid(ncid, "lat", dimID),"pb inq dim lat") 
+        CALL check_err( nf90_inquire_dimension(ncid, dimID, len = nbp_lat_src),"pb inq dim lat")
+        CALL check_err( nf90_inq_varid(ncid, 'lat', varid),"pb inq lat" )
+        ALLOCATE(lat_src(nbp_lat_src))
+        CALL check_err( nf90_get_var(ncid, varid, lat_src(:)),"pb get lat" )
+        IF (nf90_inq_dimid(ncid, 'lev', dimid) /= NF90_NOERR) THEN
+          IF (nf90_inq_dimid(ncid, 'presnivs', dimid)/= NF90_NOERR) THEN
+             CALL check_err(nf90_inq_dimid(ncid, 'PRESNIVS', dimid),'dimension lev,PRESNIVS or presnivs not in file')
+          ENDIF
+        ENDIF
+        CALL check_err( nf90_inquire_dimension(ncid, dimid, len = klev_src),"pb inq dim for PRESNIVS or lev" )
+        CALL check_err( nf90_close(ncid),"pb in close" )   
+      ENDIF
+
+      CALL bcast_mpi(nbp_lat_src)
+      CALL bcast_mpi(nbp_lon_src)
+      CALL bcast_mpi(klev_src)
+
+      IF (is_mpi_root ) THEN
+        CALL xios_set_domain_attr("domain_aerosol",nj_glo=nbp_lat_src, nj=nbp_lat_src, jbegin=0, latvalue_1d=lat_src)
+        CALL xios_set_domain_attr("domain_aerosol",ni_glo=nbp_lon_src, ni=nbp_lon_src, ibegin=0, lonvalue_1d=lon_src)
+      ELSE
+        CALL xios_set_domain_attr("domain_aerosol",nj_glo=nbp_lat_src, nj=0, jbegin=0, latvalue_1d=null_array )
+        CALL xios_set_domain_attr("domain_aerosol",ni_glo=nbp_lon_src, ni=0, ibegin=0, lonvalue_1d=null_array)
+      ENDIF
+      CALL xios_set_axis_attr("axis_aerosol",n_glo=klev_src)
+      CALL xios_set_fieldgroup_attr("aerosols", enabled=.TRUE.)
+  
+    ENDIF
+    
+  ENDIF    
+ 
+  END SUBROUTINE init_aero_fromfile
+
+
+    
+
   SUBROUTINE get_aero_fromfile(varname, cyr, filename, klev_src, pt_ap, pt_b, pt_year, psurf_out, load_out)
 !****************************************************************************************
@@ -187,9 +264,10 @@
     USE netcdf
     USE dimphy
-    USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, klon_glo, &
-                                 grid2Dto1D_glo
+    USE mod_grid_phy_lmdz, ONLY: nbp_lon_=>nbp_lon, nbp_lat_=>nbp_lat, klon_glo, &
+                                 grid2Dto1D_glo, grid_type, unstructured
     USE mod_phys_lmdz_para
     USE iophy, ONLY : io_lon, io_lat
     USE print_control_mod, ONLY: lunout
+    USE xios
 
     IMPLICIT NONE
@@ -205,6 +283,9 @@
     REAL, POINTER, DIMENSION(:)           :: pt_b         ! Pointer for describing the vertical levels      
     REAL, POINTER, DIMENSION(:,:,:)       :: pt_year      ! Pointer-variabale from file, 12 month, grid : klon,klev_src
+    REAL, POINTER, DIMENSION(:,:,:)       :: pt_year_mpi  ! Pointer-variabale from file, 12 month, grid : klon,klev_src
     REAL, DIMENSION(klon,12), INTENT(OUT) :: psurf_out    ! Surface pression for 12 months
+    REAL, DIMENSION(klon_mpi,12)          :: psurf_out_mpi    ! Surface pression for 12 months
     REAL, DIMENSION(klon,12), INTENT(OUT) :: load_out     ! Aerosol mass load in each column
+    REAL, DIMENSION(klon_mpi,12)          :: load_out_mpi     ! Aerosol mass load in each column
     INTEGER                               :: nbr_tsteps   ! number of month in file read
 
@@ -220,15 +301,39 @@
     REAL, ALLOCATABLE, DIMENSION(:)       :: varktmp
 
-    REAL, DIMENSION(nbp_lon,nbp_lat,12)   :: psurf_glo2D   ! Surface pression for 12 months on dynamics global grid
+    REAL,  ALLOCATABLE                    :: psurf_glo2D(:,:,:)   ! Surface pression for 12 months on dynamics global grid
     REAL, DIMENSION(klon_glo,12)          :: psurf_glo1D   ! -"- on physical global grid
-    REAL, DIMENSION(nbp_lon,nbp_lat,12)   :: load_glo2D    ! Load for 12 months on dynamics global grid
+    REAL,  ALLOCATABLE                    :: load_glo2D(:,:,:)    ! Load for 12 months on dynamics global grid
     REAL, DIMENSION(klon_glo,12)          :: load_glo1D    ! -"- on physical global grid
-    REAL, DIMENSION(nbp_lon,nbp_lat)      :: vartmp
-    REAL, DIMENSION(nbp_lon)              :: lon_src              ! longitudes in file
-    REAL, DIMENSION(nbp_lat)              :: lat_src, lat_src_inv ! latitudes in file
+    REAL, ALLOCATABLE, DIMENSION(:,:)     :: vartmp
+    REAL, ALLOCATABLE,DIMENSION(:)        :: lon_src              ! longitudes in file
+    REAL, ALLOCATABLE,DIMENSION(:)        :: lat_src, lat_src_inv ! latitudes in file
     LOGICAL                               :: new_file             ! true if new file format detected
     LOGICAL                               :: invert_lat           ! true if the field has to be inverted for latitudes
-
-
+    INTEGER                               :: nbp_lon, nbp_lat
+    LOGICAL,SAVE                          :: first=.TRUE.
+!$OMP THREADPRIVATE(first)
+    
+    IF (grid_type==unstructured) THEN
+      nbp_lon=nbp_lon_src
+      nbp_lat=nbp_lat_src
+    ELSE
+      nbp_lon=nbp_lon_
+      nbp_lat=nbp_lat_
+    ENDIF
+    
+    IF (is_mpi_root) THEN
+    
+      ALLOCATE(psurf_glo2D(nbp_lon,nbp_lat,12))
+      ALLOCATE(load_glo2D(nbp_lon,nbp_lat,12))
+      ALLOCATE(vartmp(nbp_lon,nbp_lat))
+      ALLOCATE(lon_src(nbp_lon))
+      ALLOCATE(lat_src(nbp_lat))
+      ALLOCATE(lat_src_inv(nbp_lat))
+    ELSE
+      ALLOCATE(varyear(0,0,0,0))
+      ALLOCATE(psurf_glo2D(0,0,0))
+      ALLOCATE(load_glo2D(0,0,0))
+    ENDIF
+            
     ! Deallocate pointers
     IF (ASSOCIATED(pt_ap)) DEALLOCATE(pt_ap)
@@ -245,41 +350,44 @@
        CALL check_err( nf90_open(TRIM(fname), NF90_NOWRITE, ncid), "pb open "//trim(fname) )
 
+
+       IF (grid_type/=unstructured) THEN
+
 ! Test for equal longitudes and latitudes in file and model
 !****************************************************************************************
        ! Read and test longitudes
-       CALL check_err( nf90_inq_varid(ncid, 'lon', varid),"pb inq lon" )
-       CALL check_err( nf90_get_var(ncid, varid, lon_src(:)),"pb get lon" )
+         CALL check_err( nf90_inq_varid(ncid, 'lon', varid),"pb inq lon" )
+         CALL check_err( nf90_get_var(ncid, varid, lon_src(:)),"pb get lon" )
        
-       IF (maxval(ABS(lon_src - io_lon)) > 0.001) THEN
-          WRITE(lunout,*) 'Problem in longitudes read from file : ',TRIM(fname)
-          WRITE(lunout,*) 'longitudes in file ', TRIM(fname),' : ', lon_src
-          WRITE(lunout,*) 'longitudes in model :', io_lon
+         IF (maxval(ABS(lon_src - io_lon)) > 0.001) THEN
+            WRITE(lunout,*) 'Problem in longitudes read from file : ',TRIM(fname)
+            WRITE(lunout,*) 'longitudes in file ', TRIM(fname),' : ', lon_src
+            WRITE(lunout,*) 'longitudes in model :', io_lon
           
-          CALL abort_physic('get_aero_fromfile', 'longitudes are not the same in file and model',1)
-       END IF
-
-       ! Read and test latitudes
-       CALL check_err( nf90_inq_varid(ncid, 'lat', varid),"pb inq lat" )
-       CALL check_err( nf90_get_var(ncid, varid, lat_src(:)),"pb get lat" )
-
-       ! Invert source latitudes
-       DO j = 1, nbp_lat
-          lat_src_inv(j) = lat_src(nbp_lat +1 -j)
-       END DO
-
-       IF (maxval(ABS(lat_src - io_lat)) < 0.001) THEN
-          ! Latitudes are the same
-          invert_lat=.FALSE.
-       ELSE IF (maxval(ABS(lat_src_inv - io_lat)) < 0.001) THEN
-          ! Inverted source latitudes correspond to model latitudes
-          WRITE(lunout,*) 'latitudes will be inverted for file : ',TRIM(fname)
-          invert_lat=.TRUE.
-       ELSE
-          WRITE(lunout,*) 'Problem in latitudes read from file : ',TRIM(fname)
-          WRITE(lunout,*) 'latitudes in file ', TRIM(fname),' : ', lat_src      
-          WRITE(lunout,*) 'latitudes in model :', io_lat
-          CALL abort_physic('get_aero_fromfile', 'latitudes do not correspond between file and model',1)
-       END IF
-
+            CALL abort_physic('get_aero_fromfile', 'longitudes are not the same in file and model',1)
+         END IF
+
+         ! Read and test latitudes
+         CALL check_err( nf90_inq_varid(ncid, 'lat', varid),"pb inq lat" )
+         CALL check_err( nf90_get_var(ncid, varid, lat_src(:)),"pb get lat" )
+
+         ! Invert source latitudes
+         DO j = 1, nbp_lat
+            lat_src_inv(j) = lat_src(nbp_lat +1 -j)
+         END DO
+
+         IF (maxval(ABS(lat_src - io_lat)) < 0.001) THEN
+            ! Latitudes are the same
+            invert_lat=.FALSE.
+         ELSE IF (maxval(ABS(lat_src_inv - io_lat)) < 0.001) THEN
+            ! Inverted source latitudes correspond to model latitudes
+            WRITE(lunout,*) 'latitudes will be inverted for file : ',TRIM(fname)
+            invert_lat=.TRUE.
+         ELSE
+            WRITE(lunout,*) 'Problem in latitudes read from file : ',TRIM(fname)
+            WRITE(lunout,*) 'latitudes in file ', TRIM(fname),' : ', lat_src      
+            WRITE(lunout,*) 'latitudes in model :', io_lat
+            CALL abort_physic('get_aero_fromfile', 'latitudes do not correspond between file and model',1)
+         END IF
+       ENDIF
 
 ! 2) Check if old or new file is avalabale.
@@ -487,60 +595,64 @@
        END IF
 
-!     - Invert latitudes if necessary
-       DO imth=1, 12
-          IF (invert_lat) THEN
-
-             ! Invert latitudes for the variable
-             varmth(:,:,:) = varyear(:,:,:,imth) ! use varmth temporarly
-             DO k=1,klev_src
-                DO j=1,nbp_lat
-                   DO i=1,nbp_lon
-                      varyear(i,j,k,imth) = varmth(i,nbp_lat+1-j,k)
-                   END DO
-                END DO
-             END DO
+
+       IF (grid_type/=unstructured) THEN
+  !     - Invert latitudes if necessary
+         DO imth=1, 12
+            IF (invert_lat) THEN
+
+               ! Invert latitudes for the variable
+               varmth(:,:,:) = varyear(:,:,:,imth) ! use varmth temporarly
+               DO k=1,klev_src
+                  DO j=1,nbp_lat
+                     DO i=1,nbp_lon
+                        varyear(i,j,k,imth) = varmth(i,nbp_lat+1-j,k)
+                     END DO
+                  END DO
+               END DO
              
-             ! Invert latitudes for surface pressure
-             vartmp(:,:) = psurf_glo2D(:,:,imth)
-             DO j=1,nbp_lat
-                DO i=1,nbp_lon
-                   psurf_glo2D(i,j,imth)= vartmp(i,nbp_lat+1-j)
-                END DO
-             END DO
+               ! Invert latitudes for surface pressure
+               vartmp(:,:) = psurf_glo2D(:,:,imth)
+               DO j=1,nbp_lat
+                  DO i=1,nbp_lon
+                     psurf_glo2D(i,j,imth)= vartmp(i,nbp_lat+1-j)
+                  END DO
+               END DO
              
-             ! Invert latitudes for the load
-             vartmp(:,:) = load_glo2D(:,:,imth)
-             DO j=1,nbp_lat
-                DO i=1,nbp_lon
-                   load_glo2D(i,j,imth)= vartmp(i,nbp_lat+1-j)
-                END DO
-             END DO
-          END IF ! invert_lat
+               ! Invert latitudes for the load
+               vartmp(:,:) = load_glo2D(:,:,imth)
+               DO j=1,nbp_lat
+                  DO i=1,nbp_lon
+                     load_glo2D(i,j,imth)= vartmp(i,nbp_lat+1-j)
+                  END DO
+               END DO
+            END IF ! invert_lat
              
-          ! Do zonal mead at poles and distribut at whole first and last latitude
-          DO k=1, klev_src
-             npole=0.  ! North pole, j=1
-             spole=0.  ! South pole, j=nbp_lat        
-             DO i=1,nbp_lon
-                npole = npole + varyear(i,1,k,imth)
-                spole = spole + varyear(i,nbp_lat,k,imth)
-             END DO
-             npole = npole/REAL(nbp_lon)
-             spole = spole/REAL(nbp_lon)
-             varyear(:,1,    k,imth) = npole
-             varyear(:,nbp_lat,k,imth) = spole
-          END DO
-       END DO ! imth
+            ! Do zonal mead at poles and distribut at whole first and last latitude
+            DO k=1, klev_src
+               npole=0.  ! North pole, j=1
+               spole=0.  ! South pole, j=nbp_lat        
+               DO i=1,nbp_lon
+                  npole = npole + varyear(i,1,k,imth)
+                  spole = spole + varyear(i,nbp_lat,k,imth)
+               END DO
+               npole = npole/REAL(nbp_lon)
+               spole = spole/REAL(nbp_lon)
+               varyear(:,1,    k,imth) = npole
+               varyear(:,nbp_lat,k,imth) = spole
+            END DO
+         END DO ! imth
        
-       ALLOCATE(varyear_glo1D(klon_glo, klev_src, 12), stat=ierr)
-       IF (ierr /= 0) CALL abort_physic('get_aero_fromfile', 'pb in allocation 3',1)
+         ALLOCATE(varyear_glo1D(klon_glo, klev_src, 12), stat=ierr)
+         IF (ierr /= 0) CALL abort_physic('get_aero_fromfile', 'pb in allocation 3',1)
        
-       ! Transform from 2D to 1D field
-       CALL grid2Dto1D_glo(varyear,varyear_glo1D)
-       CALL grid2Dto1D_glo(psurf_glo2D,psurf_glo1D)
-       CALL grid2Dto1D_glo(load_glo2D,load_glo1D)
-
+         ! Transform from 2D to 1D field
+         CALL grid2Dto1D_glo(varyear,varyear_glo1D)
+         CALL grid2Dto1D_glo(psurf_glo2D,psurf_glo1D)
+         CALL grid2Dto1D_glo(load_glo2D,load_glo1D)
+      
+      ENDIF
+      
     ELSE
-      ALLOCATE(varyear_glo1D(0,0,0))        
+        ALLOCATE(varyear_glo1D(0,0,0))        
     END IF ! is_mpi_root .AND. is_omp_root
 
@@ -566,11 +678,29 @@
     IF (ASSOCIATED(pt_year)) DEALLOCATE(pt_year)
     ALLOCATE(pt_year(klon, klev_src, 12), stat=ierr)
+    ALLOCATE(pt_year_mpi(klon_mpi, klev_src, 12), stat=ierr)
     IF (ierr /= 0) CALL abort_physic('get_aero_fromfile', 'pb in allocation 5',1)
 
-    ! Scatter global field to local domain at local process
-    CALL scatter(varyear_glo1D, pt_year)
-    CALL scatter(psurf_glo1D, psurf_out)
-    CALL scatter(load_glo1D,  load_out)
-
+    IF (grid_type==unstructured) THEN
+      IF (is_omp_master) THEN
+        CALL xios_send_field(TRIM(varname)//"_in",varyear)
+        CALL xios_recv_field(TRIM(varname)//"_out",pt_year_mpi)
+        CALL xios_send_field("load_"//TRIM(varname)//"_in",load_glo2D)
+        CALL xios_recv_field("load_"//TRIM(varname)//"_out",load_out_mpi)
+        IF (first) THEN
+          ALLOCATE(psurf_interp(klon_mpi,12))
+          CALL xios_send_field("psurf_aerosol_in",psurf_glo2D)
+          CALL xios_recv_field("psurf_aerosol_out",psurf_interp)
+        ENDIF
+      ENDIF
+      CALL scatter_omp(pt_year_mpi,pt_year)
+      CALL scatter_omp(load_out_mpi,load_out)
+      CALL scatter_omp(psurf_interp,psurf_out)
+      first=.FALSE.
+    ELSE
+      ! Scatter global field to local domain at local process
+      CALL scatter(varyear_glo1D, pt_year)
+      CALL scatter(psurf_glo1D, psurf_out)
+      CALL scatter(load_glo1D,  load_out)
+    ENDIF
 ! 7) Test for negative values
 !****************************************************************************************
